MAIN_BRANCHES_LIST = ["main", "master", "dev", "develop", "development"]

INITIAL_COMMIT = [
    "Initial commit",  # Generated by GitLab
    "Add README.md",  # Generated by GitKraken
]

COMMIT_DELIMITER = "--commit-delimiter--"

MIN_COMMIT_DESCR_LENTH = 10

MAX_COMMIT_DESCR_LINES = 20

SUCCESS = "Commit validation: success!"

FAILED = "Commit validation: failed!"

TITLE_FAILED = "Please enter a commit message in the conventional commits format."

BODY_FAILED = (
    "The commit description contains a conventional commit prefix "
    f"or a line of less than {MIN_COMMIT_DESCR_LENTH} characters.\n"
    "Did you forget to edit and clean up the commit message after a squash?"
)

MERGE_FAILED = "Commit merges should have at least one approver."

EMOJI_CHECK = ":check_mark_button:"
EMOJI_CROSS = ":cross_mark:"

COMMIT_TYPE_MUST_HAVE_SCOPE = (
    "Commits of type '{type}' must be of the form '{type}(add)', "
    "'{type}(change)' or '{type}(remove)'"
)

COMMIT_TYPE_MUST_NOT_HAVE_SCOPE = (
    "Commits of type '{}' must not specify a scope but simply use the form '{}'"
)

PATTERN = (
    r"(?s)"  # To explictly make . match new line
    r"(build|bump|ci|deps|docs|enabler|feat|fixbug|refactor|test)"  # type
    r"(\(\S+\))?!?:"  # scope
    r"( [^\n\r]+)"  # subject
    r"((\n\n.*)|(\s*))?$"
)

MAJOR_COMMIT_TYPES = ["enabler", "feat", "fixbug", "refactor"]

COMMIT_WITH_SCOPE = ["deps", "feat"]

JAMA_REGEX = r"SmlPrep-SUBSR-\d+"

JAMA_TAG = "JAMA:"

IMPACT_TAG = "IMPACT:"
